import express from 'express';
const router = express.Router();
import jsonwebtoken from 'jsonwebtoken';
import sqlite from 'better-sqlite3';
import path from 'path';
import { v4 as uuidv4 } from 'uuid';
import dayjs from 'dayjs';

// Name der Datenbankdatei, die im Ordner "routes" abgelegt ist.
const dbPath = path.resolve("./src/db/", 'rental.db');

// Verbindung zur Datenbank herstellen
let db = new sqlite(dbPath);

// Alle Nutzer abrufen. localhost:3005/api/user/all
router.post('/', async (req, res, next) => {
  if ( req.body.hasOwnProperty("username")
      && req.body.hasOwnProperty("password")) {
      let username = req.body.username;
      let password = req.body.password;
      let users = await db.prepare('SELECT * from Persons WHERE username = ?').all(username);
      console.log("users");
      console.log(users); 
        if (users.length === 0) {
            return res.send({ success: "error", message: "invalid username" });
        }

        if (users[0].pwd === password) {
            let userObject = {
              id: users[0].id,
              username: users[0].username,
              prename: users[0].prename,
              surname: users[0].surname,
              imageLink: users[0].img,
              adminRole: users[0].adminRole
            }
            const secret = "oRs2ciVCayoy5f64";
            let endDate = dayjs().add(7, 'days').unix(); 
            console.log(endDate); 
            let tokenObject = { 
               username: users[0].username, 
               endDate: endDate, 
               adminRole: users[0].adminRole
            } 
            const token = jsonwebtoken.sign(tokenObject , secret);
            console.log("Token: "  + token);
 
            res.send({success: "ok", message: "login successful", user: userObject, token: token});
        } else {
          res.send({success: "error", message: "invalid credentials"});
        }  
      } else {
        res.send({success: "error", message: "attributes missing"});
      }
});

router.post('/register', async (req, res, next) => {
  if (   req.body.hasOwnProperty("username")
      && req.body.hasOwnProperty("password") 
      && req.body.hasOwnProperty("prename")
      && req.body.hasOwnProperty("surname")
      && req.body.hasOwnProperty("city")
      && req.body.hasOwnProperty("age")) 
  {
    let id = uuidv4();
    let username = req.body.username;
    // bcrypt.compareSync(password, userToCompare.dataValues.hash)
    let password = req.body.password; 
    let prename = req.body.prename; 
    let surname = req.body.surname;
    let age = req.body.age;
    let city = req.body.city;
    
    let users = await db.prepare('SELECT * from Persons WHERE username = ?').all(username);
    if (users.length > 0) {
      return res.send({ success: "error", message: "username already exists" });
    }

    let added = db.prepare("INSERT INTO Persons (id, prename, surname, age, city, username, pwd) VALUES (?,?,?,?,?,?,?)")
                .run(id, prename, surname, age, city, username, password);
    res.send({success: "ok", message: "register successful"});
  } else {
    res.send({success: "error", message: "attributes missing"});
  }
});

export default router;

