let express = require('express');
let router = express.Router();
const { PrismaClient } = require('@prisma/client');
const prisma = new PrismaClient();

router.get('/', async (req, res) => {
    const persons = await prisma.person.findMany();
    res.json({ success: "ok", message: "persons sent", persons: persons});
});

router.post('/', async (req, res) => {
    if (req.body.hasOwnProperty("prename")
        && req.body.hasOwnProperty("surname")
        && req.body.hasOwnProperty("username")
        && req.body.hasOwnProperty("password")) {
        const {prename, surname, username, password} = req.body;
        const newPerson = await prisma.person.create({
            data: {prename, surname, username, password},
        });
        res.json({ success: "ok", message: "person added", person: newPerson});
    } else {
        res.json({ success: "error", message: "attributes missing"});
    }
});

router.put('/', async (req, res) => {
    if ( req.body.hasOwnProperty("id")
        && req.body.hasOwnProperty("prename")
        && req.body.hasOwnProperty("surname")
        && req.body.hasOwnProperty("username")
        && req.body.hasOwnProperty("password")) {
        const { id, prename, surname, username, password } = req.body;
        const updatedPerson = await prisma.person.update({
           where: { id },
           data: { prename, surname, username, password },
        });
        res.json({ success: "ok", message: "person added", person: updatedPerson});
    } else {
        res.json({ success: "error", message: "attributes missing"});
    }
});

router.delete('/:id', async (req, res) => {
    const { id } = req.params;
    await prisma.person.delete({
        where: { id },
    });
    res.json({ success: "ok", message: "person deletet"});
});
module.exports = router;